(function($) {
    $.fn.keyword = function() {
    	var isMobile = /iPhone|iPad|iPod|Android/i.test(navigator.userAgent);
    	return this.each(function() {
    		var id = Math.random().toString(36).substring(4);
    		var select = $(this);
    		var list = [];
    		var keys = {};
    		var val = "";
    		var max = 5;
			if(isMobile){
				
			} else {
				var h = "";
				$(select).find("option").each(function(i,o){
					var selected = ($(this).prop("selected")) ? 1 : 0;
					keys[$(this).attr("value")] = selected;
					list.push({id:$(this).attr("value"),text:$(this).html(),active:selected});
					if($(this).prop("selected")) h+="<option value='"+$(this).attr("value")+"' selected>"+$(this).html()+"</option>";
				});	
				$(select).html(h);
				var selectHtml = "<span class='select-container'>Select item <input type='text'/></span>";
				select.after('<span class="multi" id="select-'+id+'"></span>');
				select.css("position","absolute")
					.css("height","0")
					.css("opacity","0");
			}
			var container = $("#select-"+id);
    		
    		var app = {
				change:function(t){
					app.update($(t).val());
				},
				update:function (id){
					var h = "";
					$(list).each(function(i,o){
						if(o.id==id) {
							o.active = (o.active) ? 0 : 1;
						}
						if(o.active) h+= "<option value='"+o.id+"' selected>"+o.text+"</option>";
					});
					$(select).html(h);
					val = "";
					$(container).removeClass("active");
					app.resetInput();
					app.render();
				},
				remove:function (t){
					app.update($(t).data('id'));
				},
				render:function (){
					var htmlSelect = "";
					var htmlTags = "";
					var htmlList = "";
					var x = 0;
					$(list).each(function(i,o){
						if(o.active) {
							htmlTags+="<span class='tag' data-id='"+o.id+"'>"+o.text+" </span>"
						} else {
							if(x<max) htmlList+="<tr><td data-id='"+o.id+"'>"+o.text+"</td></tr>";
							x++;
						}
					});	
					
					
					htmlSelect = "<span class='select-container'> <input type='text' placeholder='Select item'/></span><span class='select-dropdown'><table>"+htmlList+"</table></span>";	
					
					$(container).html(htmlTags+htmlSelect);
					$(container).find("input").focus(function(){
						var p = $(this).parent().parent();
						if(!$(p).hasClass("active")) $(p).addClass("active");
					});
					$(container).find("input").blur(function(){
						var p = $(this).parent().parent();
						$(p).removeClass("active");
						app.resetInput();
					});
					$(container).find("input").keyup(function(){
						var v = $(this).val().toLowerCase();
						if(val!=v) {
							val = v;
							app.renderList();
						}
					});
					$(container).find(".select-dropdown td").on("mousedown", function(){
						app.update($(this).data("id"));
					});
					
					$(container).find(".tag").click(function(){
						app.remove(this);
					});
					
					$(container).find("input")
						//.css("opacity",0)
						.css("position","absolute")
						.css("width","100%")
						.css("left",0);
				},
				mobileRender:function(addListeners){
					var select = $(container).find("select");
					var ids = $(select).val();
					var tags = $(container).find(".tags");
					var h = "";
					$(select).find("option").each(function(i,o){
						if($(this).prop("selected")) h+="<span class='tag' data-id='"+$(this).val()+"'>"+$(this).text()+" </span>"
					});
					$(tags).html(h);
					if(addListeners) app.mobileListeners();
				},
				mobileListeners:function(){
					$(container).find("select").change(function(){
						app.mobileRender();
					});
					$(container).find("select")
						.css("opacity",0)
						.css("position","absolute")
						.css("width","100%")
						.css("left",0);
				},
				resetInput:function(){
					$(container).find("input").val("");
					val = "";
				},
				renderList:function(){
					var h = "";
					var x =0;
					$(list).each(function(i,o){
						var start = o.text.toLowerCase().indexOf(val);
						if(!o.active && start >= 0) {
							var split = o.text.split(val);
							if(x<max) h+="<tr><td data-id='"+o.id+"'>"+split.join("<span>"+val+"</span>")+"</td></tr>";
							x++;
						}
					});	
					$(container).find(".select-dropdown table").html(h);
					$(container).find(".select-dropdown td").on("mousedown", function(){
						app.update($(this).data("id"));
					});
				}
			}
			
			if(isMobile) {
				app.mobileRender(true);
			} else {
				app.render();
				/*select.change(function(){
					app.render();
				});*/
			}
   		 });
    }
})(jQuery);